unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Image2: TImage;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type carte = record
             nord,est,sud,ouest : integer;
             end;

const  TETE1 = 1; CORPS1 = -1;  {--- rouge ---}
       TETE2 = 2; CORPS2 = -2;  {--- vert ---}
       TETE3 = 3; CORPS3 = -3;  {--- bleu ---}
       TETE4 = 4; CORPS4 = -4;  {--- jaune ---}

var t        : array[1..9] of carte;
    longueur : byte;
    st       : string;
    ch       : char;
    car      : carte;
    nb       : longint;
    num      : integer;

(************************************************************************)

function MyColor(code:integer):TColor;
begin
     case abs(code) of
          1 : result:=clRed;
          2 : result:=clLime;
          3 : result:=clBlue;
          4 : result:=clYellow;
     end;
end;

procedure Dessine(cnv:TCanvas;offx,offy,cote:integer);
var x,y,d,x1,y1,x2,y2,x3,y3,x4,y4: integer; s:string;
begin
    d:=cote div 3;
    with cnv do
          begin
          for y:=0 to 2 do
              for x:=0 to 2 do
              begin
                 brush.style:=bsSolid;
                 //effacer
                 brush.color:=clWhite;
                 pen.style:=psClear;
                 rectangle(offx+x*cote,offy+y*cote,offx+x*cote+cote,offy+y*cote+cote);

                 pen.style:=psSolid;  //a dpend des gots ;-)

                 //Nord
                 brush.color:=MyColor(t[x+1+3*y].nord);
                 x1:=offx+x*cote+d;
                 y1:=offy+y*cote-(d div 2);
                 x2:=x1+d;
                 y2:=y1+d;
                 x3:=x1;
                 y3:=y1+(d div 2);
                 x4:=x2;
                 y4:=y3;
                 Chord(x1,y1,x2,y2,x3,y3,x4,y4);
                 //Est
                 brush.color:=MyColor(t[x+1+3*y].est);
                 x1:=offx+(x+1)*cote-(d div 2);
                 y1:=offy+y*cote+d;
                 x2:=x1+d;
                 y2:=y1+d;
                 x3:=x1+(d div 2);
                 y3:=y1;
                 x4:=x3+d;
                 y4:=y3;
                 Chord(x1,y1,x2,y2,x3,y3,x4,y4);
                 //Sud
                 brush.color:=MyColor(t[x+1+3*y].sud);
                 x1:=offx+x*cote+d;
                 y1:=offy+(y+1)*cote-(d div 2);
                 x2:=x1+d;
                 y2:=y1+d;
                 x3:=x2;
                 y3:=y1+(d div 2);
                 x4:=x1;
                 y4:=y3;
                 Chord(x1,y1,x2,y2,x3,y3,x4,y4);
                 //Ouest
                 brush.color:=MyColor(t[x+1+3*y].ouest);
                 x1:=offx+x*cote-(d div 2);
                 y1:=offy+y*cote+d;
                 x2:=x1+d;
                 y2:=y1+d;
                 x3:=x1+(d div 2);
                 y3:=y2;
                 x4:=x3;
                 y4:=y1;
                 Chord(x1,y1,x2,y2,x3,y3,x4,y4);

                 brush.style:=bsClear;
                 pen.style:=psSolid;
                 pen.color:=clBlack;
                 rectangle(offx+x*cote,offy+y*cote,offx+x*cote+cote,offy+y*cote+cote);

                 s:=st[x+1+3*y];
                 if cnv=Form1.Image1.Canvas then Font:=Form1.Label1.Font;
                 if cnv=Form1.Image2.Canvas then Font:=Form1.Label2.Font;
                 TextOut(offx+x*cote+(cote-TextWidth(s)) div 2,offy+y*cote+(cote-TextHeight(s)) div 2,s);
             end;
          end;
end ;


//************************************************************************

function carte_ok(nb : integer) : boolean;
begin
   case nb of
   1 : carte_ok:=true;
   2 : carte_ok:=t[1].est+t[2].ouest=0;
   3 : carte_ok:=t[2].est+t[3].ouest=0;
   4 : carte_ok:=t[1].sud+t[4].nord=0;
   5 : carte_ok:=(t[2].sud+t[5].nord=0) and (t[4].est+t[5].ouest=0);
   6 : carte_ok:=(t[3].sud+t[6].nord=0) and (t[5].est+t[6].ouest=0);
   7 : carte_ok:=(t[4].sud+t[7].nord=0);
   8 : carte_ok:=(t[5].sud+t[8].nord=0) and (t[7].est+t[8].ouest=0);
   9 : carte_ok:=(t[6].sud+t[9].nord=0) and (t[8].est+t[9].ouest=0);
   end;
end;

//***********************************************************************

procedure init_carte(var c : carte;nord,est,sud,ouest : integer);
begin
c.nord:=nord;c.est:=est;c.sud:=sud;c.ouest:=ouest;
end;

procedure initialisation;
begin
num:=0;
st:='123456789';
init_carte(t[1],CORPS1,TETE4,CORPS2,TETE3 );
init_carte(t[2],TETE2,TETE4,TETE1,TETE3 );
init_carte(t[3],CORPS3,TETE4,CORPS2,TETE1 );
init_carte(t[4],CORPS1,TETE4,TETE1,TETE3 );
init_carte(t[5],CORPS3,TETE2,TETE1,CORPS4);
init_carte(t[6],TETE2,TETE4,TETE1,TETE3 );
init_carte(t[7],CORPS1,CORPS3,CORPS2,CORPS4);
init_carte(t[8],TETE4,CORPS3,TETE1,CORPS2);
init_carte(t[9],TETE2,CORPS3,CORPS2,CORPS4);
end;

//***********************************************************************

procedure rotation_droite(var c : carte);
var b : integer;
begin
b:=c.nord;
c.nord:=c.ouest;c.ouest:=c.sud;c.sud:=c.est;c.est:=b;
end;

procedure rotations(numero : integer);
var i : integer;
begin
if numero=10 then
   begin
   Dessine(Form1.Image1.Canvas,0,0,Form1.Image1.Width div 3);
   Screen.Cursor:=crDefault;
   inc(num);
   Form1.Label1.Caption:='Solution '+IntToStr(num);
   showmessage('Solution '+IntToStr(num)+' - Cartes : '+st);
   Screen.Cursor:=crHourGlass;
   end
else
   for i:=1 to 4 do
       begin
       rotation_droite(t[numero]);
       if carte_ok(numero) then rotations(numero+1);
       end;
end;

procedure anagram(i : byte);
var j : byte;
begin
if i = 9 then rotations(1)
else
   for j := i to 9 do
       begin
       car:=t[i];t[i]:=t[j];t[j]:=car;
       ch:=st[i];st[i]:=st[j];st[j]:=ch;
       anagram (i+1);
       car:=t[i];t[i]:=t[j];t[j]:=car;
       ch:=st[i];st[i]:=st[j];st[j]:=ch;
       end
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
initialisation;
Screen.Cursor:=crHourGlass;
anagram(1);
Screen.Cursor:=crDefault;
showmessage('C''est tout !');
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
Label1.Caption:='Voici la situation de dpart :';
initialisation;
Dessine(Image2.Canvas,0,0,Image2.Width div 3);
Dessine(Image1.Canvas,0,0,Image1.Width div 3);
end;

end.
